//
//  ZPNsUtils.m
//  zego_zpns
//
//  Created by 武耀琳 on 2023/6/29.
//

#import "ZPNsUtils.h"

@implementation ZPNsUtils

+(bool)wirteCustomLog:(NSString *)customLog{
    Class ZIM = NSClassFromString(@"ZIM");
    if ([[NSClassFromString(@"ZIM") alloc] init] != nil) {
        SEL selector = NSSelectorFromString(@"writeCustomLog:moduleName:");
        IMP imp = [ZIM methodForSelector:selector];
        void (*func)(id, SEL, NSString *,NSString *) = (void (*)(id, SEL, NSString *, NSString *))imp;
        func(ZIM, selector, customLog,@"ZPNs SDK");
        return true;
    }
    return false;
}

+ (NSString *)getHexStringForData:(NSData *)data {
#if TARGET_OS_IPHONE
    if ([[[UIDevice currentDevice] systemVersion] floatValue] >= 13) {

        if (![data isKindOfClass:[NSData class]]) {
            return @"";
        }
        NSUInteger len = [data length];
        char *chars = (char *)[data bytes];
        NSMutableString *hexString = [[NSMutableString alloc] init];
        for (NSUInteger i = 0; i < len; i++) {
            [hexString appendString:[NSString stringWithFormat:@"%0.2hhx", chars[i]]];
        }
        return hexString;
    } else {
        NSString *myToken = [[data description]
            stringByTrimmingCharactersInSet:[NSCharacterSet
                                                characterSetWithCharactersInString:@"<>"]];
        myToken = [myToken stringByReplacingOccurrencesOfString:@" " withString:@""];
        return myToken;
    }
#endif
#if TARGET_OS_OSX
    if (![data isKindOfClass:[NSData class]]) {
        return @"";
    }
    NSUInteger len = [data length];
    char *chars = (char *)[data bytes];
    NSMutableString *hexString = [[NSMutableString alloc] init];
    for (NSUInteger i = 0; i < len; i++) {
        [hexString appendString:[NSString stringWithFormat:@"%0.2hhx", chars[i]]];
    }
    return hexString;
#endif
}

@end
